/* S2T_RO.h
 * Acorn-specific header for SNAtoTAP
 *
 * Author: Darren Salt
 */

/*
 * The following declarations are intended to facilitate use RISC OS error
 * messages rather than those generated by the SharedCLibrary (errno)
 */

typedef struct {
  int errnum;
  char errmess[252];
} _kernel_oserror;

extern _kernel_oserror *_kernel_last_oserror(void);

/*
 * These declarations make life *much* easier for SPConv :-)
 */

struct stat {
  int st_size;
};

#define HAVE_STRICMP
int stricmp(const char*, const char*);

int fileType(const char* file);
/* Returns the filetype of the given file */

int stat(const char* file, struct stat* status);
/* Returns the length (in *status) of the given file */

_kernel_oserror *_setType(const char* file, int type);
/* Sets the filetype of the given file */

void setvar(const char* text);

void ro_perror(void);

#define unlink(x) /* Not really needed; not in GSTStubs anyway */

#define perror(p) ro_perror()

/*
 * The following #undefs require that gcc:h.stdio has already been seen. We
 * need to use the *functions* not the macros, since while the declarations
 * match, the definitions differ somewhat.
 */

#undef feof
#undef ferror
#undef clearerr
#undef getc
#undef getchar
#undef putc
#undef putchar
#undef memcpy
